/* ===================================================================
** Nzev souboru   : touch.c
** Mikrokontroler  : ATmega16
** Popis           : Funkce pro ovldn digitlnho touchscreenu
**
** Autor           : Petr Marc
** Pedmt         : Mikroprocesory pro pstrojov aplikace
** Kompiltor	   : AVG-GCC
** Posledn zmna  : 27.04.09
** Funkce jsou psny univerzln, jedin co mus b doreno, je to, e 
** jednotliv piny musej bt v danm portu, ale je jedno v jakm poad
** Funknost programu spov v tom,e se cyklicky vysl do jednotlivch
** dk logick rove "L" a pokud je stisknut dan dotykov bod, tak se 
** logick rove L penese i do sloupce a tato hodnota je snmna na vstupech
** ===================================================================
*/

/*
** Hlavikov soubory
*/
#include <avr\io.h>			// hlavikov soubor pro mikrokontrolr ATmega16
#include <avr/pgmspace.h>
#define  F_CPU 16000000UL	// frekvence krystalu (nutne pro delay.h)
#include <util/delay.h>     // hlavikov soubor pro zpodn
#include "touch.h"          // hlavikov soubor pro obsluhu touchscreenu


/*
** Globln promnn
*/
;unsigned int Tx,Ty ;		// souadnice jednotlivch bod touchscreenu
/***********************************************************************
 Prototypy funkc
************************************************************************/
void Toch_Col_Test (void);

/***********************************************************************
 Funkce pro testovn sloupc
************************************************************************/
void Toch_Col_Test (void)
{  _delay_ms( 100 ) ;		// zpozdeni 100ms
  
	if bit_is_clear (TOUCH_COL_PIN,COL_1)   Tx=1;	// testovn vstup
	if bit_is_clear (TOUCH_COL_PIN,COL_2)   Tx=2;
	if bit_is_clear (TOUCH_COL_PIN,COL_3)   Tx=3;
	if bit_is_clear (TOUCH_COL_PIN,COL_4)   Tx=4;
	if bit_is_clear (TOUCH_COL_PIN,COL_5)   Tx=5;
	if bit_is_clear (TOUCH_COL_PIN,COL_6)   Tx=6;
	if bit_is_clear (TOUCH_COL_PIN,COL_7)   Tx=7;
	if bit_is_clear (TOUCH_COL_PIN,COL_8)   Tx=8;
	if bit_is_clear (TOUCH_CLRW_PIN,COL_9)  Tx=9;
	if bit_is_clear (TOUCH_CLRW_PIN,COL_10) Tx=10;
	 _delay_ms( 10 );
}
/***********************************************************************
 Funkce pro zjisteni dotyku
 Funkce je psana univerzalne, s tim ze nevim ktere piny budou konkretne 
 definovany, velke zjednoduseni by bylo kdyby byly piny nebyly prehazene,
 stacilo by pote jen rolovani bitu a cyklus for
************************************************************************/
void touch ( void )
{	Tx = 0;
	Ty = 0;

	TOUCH_CLRW_PORT |= (_BV(ROW_5));			// nulovn prvnho dku
	TOUCH_CLRW_PORT &= ~(_BV(ROW_1));
	Toch_Col_Test ();
	if (Tx) { Tx=0;
			  Toch_Col_Test ();
			  if (Tx) Ty=1;
			  TOUCH_CLRW_PORT |= (_BV(ROW_1)); // nastaven prvnho dku
			 }
	
	else
	{   _delay_ms( 100 ) ;		// zpozdeni

	TOUCH_CLRW_PORT |= (_BV(ROW_1));	   	// nulovn druhho dku
 	TOUCH_CLRW_PORT &= ~(_BV(ROW_2));
	Toch_Col_Test ();
	if (Tx) { Tx=0;Ty=0;
			  Toch_Col_Test ();
			  if (Tx) Ty=2;
			  TOUCH_CLRW_PORT |= (_BV(ROW_2)); // nastaven prvnho dku
			 }

		else
			{
			TOUCH_CLRW_PORT |= (_BV(ROW_2));	// nulovn tetho dku
			TOUCH_CLRW_PORT &= ~(_BV(ROW_3));
			Toch_Col_Test ();
			if (Tx) 
				{ Tx=0;Ty=0;
				Toch_Col_Test ();
			   	if (Tx) Ty=3;
			    TOUCH_CLRW_PORT |= (_BV(ROW_3)); // nastaven prvnho dku
				}			
				
			else
				{
				TOUCH_CLRW_PORT|= (_BV(ROW_3));	// nulovn tvrtho dku
				TOUCH_CLRW_PORT &= ~(_BV(ROW_4));
				Toch_Col_Test ();
			if (Tx) 
				{ Tx=0;Ty=0;
				Toch_Col_Test ();
			   	if (Tx) Ty=4;
			    TOUCH_CLRW_PORT |= (_BV(ROW_4)); // nastaven prvnho dku
				}	

				else
					{
					TOUCH_CLRW_PORT |= (_BV(ROW_4)); // nulovn ptho dku
					TOUCH_CLRW_PORT &= ~(_BV(ROW_5));
					Toch_Col_Test ();
					if (Tx) 
						{ Tx=0;Ty=0;
						Toch_Col_Test ();
			 		  	if (Tx) Ty=5;
			 		    TOUCH_CLRW_PORT |= (_BV(ROW_5)); // nastaven prvnho dku
						}	

					}//else 4
				} // else 3
			} // else 2
		}//else */
}


// ***********************************************************************
// Funkce pro inicializaci dotykovho panelu
// ***********************************************************************
void touch_init( void ) 
{
	TOUCH_COL_DDR  = 0x00;	// Port pro sloupce je definovn jako vstupn
	TOUCH_CLRW_DDR = 0x00;	// Port pro sloupce je definovan jako vstupn
	TOUCH_CLRW_DDR = ((_BV(5))|(_BV(ROW_1))|(_BV(ROW_2))|(_BV(ROW_3))|(_BV(ROW_4))|(_BV(ROW_5)));
							// Nastaven dk jako vstupy :
	TOUCH_COL_PORT = 0xFF;	// Nastaven pull up rezistor pro vechy vstupy
	TOUCH_CLRW_PORT = 0xFF;	// Nastaven pull up rezistor pro vechy vstupy a zrove v
							// vysln logickch jedniek na vstupy
}
//----------------------------------------------------------------------



