/*
** ===================================================================
** Nzev souboru   : touch.h
** Mikrokontroler  : ATmega16
** Popis           : Funkce pro ovldn digitlnho touchscreenu
**
** Autor           : Petr Marc
** Pedmt         : Mikroprocesory pro pstrojov aplikace
** Kompiltor	   : AVG-GCC
** Posledn zmna  : 04.04.09
** Funkce je psan univerzln, jedin co mus b doreno, je to, e 
** jednotliv piny musej bt v danm portu, ale je jedno v jakm poad
** ===================================================================
*/
#ifndef _TOUCH_H
#define _TOUCH_H 1

// port touchscreenu
#define TOUCH_COL_PORT	PORTB				// signly ze sloupc				
#define TOUCH_COL_PIN	PINB
#define TOUCH_COL_DDR	DDRB				// vechny sloupce jsou nastaveny jako vstupy

// port touchscreenu
#define TOUCH_CLRW_PORT	PORTD				// signly ze sloupc a dc signly
#define TOUCH_CLRW_PIN	PIND
#define TOUCH_CLRW_DDR	DDRD				// A[0..4] vystupy, A[6,7] vstupy

// definice sloupc touchscreenu
#define COL_1		PB0
#define COL_2		PB1
#define COL_3		PB2
#define COL_4		PB3
#define COL_5		PB4
#define COL_6		PB5
#define COL_7		PB6
#define COL_8		PB7

// definice sloupc a dk touchscreenu
#define ROW_1		PD0
#define ROW_2		PD1
#define ROW_3		PD2
#define ROW_4		PD3
#define ROW_5		PD4
#define COL_9		PD6					// posledni dva bity jsou pro cteni sloupcu
#define COL_10		PD7


/*
** Prototypy funkc
*/
extern unsigned int Tx,Ty;
void touch_init( void ) ;	// inicializace dotykovho panelu
void touch (void);			// funkce pro ziskani mista dotyku, vsledn souadnice
							// jsou uloeny v promnnch Tx,Ty	

//-----------------------------------------------------------------------
#endif


/*
** Konec hlavikovho souboru
*/
